package com.example.ayudapy

import android.os.Bundle
import androidx.appcompat.app.AppCompatActivity
import androidx.lifecycle.Observer
import androidx.lifecycle.ViewModelProviders
import androidx.recyclerview.widget.LinearLayoutManager
import androidx.recyclerview.widget.RecyclerView
import com.example.ayudapy.adapter.RecyclerViewAdapter
import com.example.ayudapy.db.PedidoViewModel
import com.example.ayudapy.db.pedidoDataBase
import kotlinx.android.synthetic.main.pendientes_lista.*


class PendienteLista : AppCompatActivity() {
    private lateinit var model: PedidoViewModel
    private lateinit var mDb: pedidoDataBase
    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.pendientes_lista)

        // Get the view model
        model = ViewModelProviders.of(this).get(PedidoViewModel::class.java)

        // Specify layout for recycler view
        val linearLayoutManager = LinearLayoutManager(
            this, RecyclerView.VERTICAL,false)
        recycler_view.layoutManager = linearLayoutManager


        // Observe the model
        model.allPedidos.observe(this, Observer{ pedido->
            // Data bind the recycler view
            recycler_view.adapter =
                RecyclerViewAdapter(pedido)
        })


    }

}
