package com.example.ayudapy.adapter

import android.content.Context
import android.os.Build
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.annotation.RequiresApi
import androidx.recyclerview.widget.RecyclerView
import com.example.ayudapy.R
import com.example.ayudapy.db.PedidoSave
import com.example.ayudapy.db.pedidoDataBase
import kotlinx.android.synthetic.main.pendientes_items.view.*
import java.time.LocalDateTime
import java.time.format.DateTimeFormatter


class RecyclerViewAdapter(val pedido: List<PedidoSave>)
    : RecyclerView.Adapter<RecyclerViewAdapter.ViewHolder>(){

    lateinit var context: Context
    private lateinit var db: pedidoDataBase

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int)
            : ViewHolder {
        val v: View = LayoutInflater.from(parent.context)
            .inflate(R.layout.pendientes_items,parent,false)
        return ViewHolder(v)
    }




    @RequiresApi(Build.VERSION_CODES.O)
    override fun onBindViewHolder(holder: ViewHolder, position: Int) {
       // localDate.getDayOfMonth();
        //localDate.getMonthValue();

        val formatter = DateTimeFormatter.BASIC_ISO_DATE
        val formatted = pedido[position].added.format(formatter)

        val fecha = formatted.substring(8..9)

      //  dateTime.format(DateTimeFormatter.ofLocalizedTime(FormatStyle.MEDIUM))
        val parsedDate = LocalDateTime.parse(pedido[position].added, DateTimeFormatter.ISO_DATE_TIME)
        val formatteDate = parsedDate.format(DateTimeFormatter.ofPattern("dd MMM yyyy HH:mm"))

        val mes = formatteDate.substring(3..5)

        println("Este es el substring de mes: $mes y este es formateadp $formatteDate")

        holder.date_day.text = fecha
        holder.date_month.text = mes.toUpperCase()
        holder.title.text = pedido[position].title
        holder.message_view.text = pedido[position].message

        holder.delete_layout.setOnClickListener {
            //Toast.makeText(context,"clicked",Toast.LENGTH_SHORT).show()
            println("Hace clic ")
           // val pedido = Thread{
                db.daoPedido().delete(pedido[position])
         //   }
         //   pedido.start()

        }



    }


    override fun getItemCount(): Int {
        return pedido.size
    }

    override fun getItemId(position: Int): Long {
        return super.getItemId(position)
    }

    override fun getItemViewType(position: Int): Int {
        return super.getItemViewType(position)
    }


    class ViewHolder(itemView:View): RecyclerView.ViewHolder(itemView){
        val date_day = itemView.date_day
        val date_month = itemView.date_month
        val title = itemView.title
        val message_view = itemView.message_view
        val delete_layout = itemView.delete_layout



    }
}

